unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, unit3, ExtCtrls, StdCtrls, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPClient, IdSNTP, idglobal, mmsystem, IdTCPConnection, IdTCPClient, IdHTTP;


type Tdatapair=record
        time,tx,rx:single;
end;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    lmeasevent: TLabel;
    Label2: TLabel;
    lpcrelative: TLabel;
    lpcrelerr: TLabel;
    Label3: TLabel;
    Timer1: TTimer;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    pb: TPaintBox;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    GroupBox5: TGroupBox;
    Memo1: TMemo;
    udp: TIdUDPClient;
    Timer2: TTimer;
    http: TIdHTTP;
    CheckBox1: TCheckBox;
    procedure radiochg(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    showflag:boolean;
    sampler:Trxer;
    deltalasttik:double;
    initialref,initialntp,ntpgap:double;
    initialsample,probeinterval:integer;

    data:array of Tdatapair;
    dataix:integer;
    yspan:double;
    sum_roundtrip:extended;
    suppresslimit,bestfit:double;

    rx_cantilever_cor,rx_cantilever_unc:double;

    function getxtime:extended;

    procedure compute_cantilevers_max(cor:double; var p1:double; var p2:double; var p3:double);
    procedure compute_cantilevers_min(cor:double; var p1:double; var p2:double; var p3:double);

    procedure cantilever_track;

  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  //checkbox1.checked:=true;
  initialsample:=2;
end;

procedure TForm1.cantilever_track;
var p1,p2,p3,e:double;
begin
  if dataix<2 then exit;
  //txtime is negative, with the max peaks being the best
  //rxtime is positive, with the min peaks being the best

  //the time becomes positive then the clock under test is fast.

  compute_cantilevers_min(rx_cantilever_cor,p1,p2,p3);
  e:=p3-p1; //positive if fast.

  rx_cantilever_cor:=rx_cantilever_cor-e/(data[dataix-1].time-data[0].time);


//  label6.caption:=floattostrf(-rx_cantilever_cor*1E6,fffixed,20,3);

{
  compute_cantilevers_max(rx_cantilever_cor,p1,p2,p3);
  e:=p3-p1; //positive if fast.

  rx_cantilever_cor:=rx_cantilever_cor-e/(data[dataix-1].time-data[0].time);


  label6.caption:=floattostrf(-rx_cantilever_cor*1E6,fffixed,20,3);
 }



end;

procedure TForm1.compute_cantilevers_max(cor:double; var p1:double; var p2:double; var p3:double);
var i,n1,n2:integer;
    pk,y:double;
begin
  n1:=((dataix*0) div 3);
  n2:=((dataix*1) div 3)-1;
  pk:=data[n1].tx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].tx+data[i].time*cor;
    if y>pk then pk:=y;
  end;
  p1:=y;

  n1:=((dataix*1) div 3);
  n2:=((dataix*2) div 3)-1;
  pk:=data[n1].tx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].tx+data[i].time*cor;
    if y>pk then pk:=y;
  end;
  p2:=y;

  n1:=((dataix*2) div 3);
  n2:=((dataix*3) div 3)-1;
  pk:=data[n1].tx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].tx+data[i].time*cor;
    if y>pk then pk:=y;
  end;
  p3:=y;
end;

procedure TForm1.compute_cantilevers_min(cor: double; var p1, p2, p3: double);
var i,n1,n2:integer;
    pk,y:double;
begin
  n1:=((dataix*0) div 3);
  n2:=((dataix*1) div 3)-1;
  pk:=data[n1].rx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].rx+data[i].time*cor;
    if y<pk then pk:=y;
  end;
  p1:=y;

  n1:=((dataix*1) div 3);
  n2:=((dataix*2) div 3)-1;
  pk:=data[n1].rx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].rx+data[i].time*cor;
    if y<pk then pk:=y;
  end;
  p2:=y;

  n1:=((dataix*2) div 3);
  n2:=((dataix*3) div 3)-1;
  pk:=data[n1].rx+data[n1].time*cor;
  for i:=n1 to n2 do begin
    y:=data[i].rx+data[i].time*cor;
    if y<pk then pk:=y;
  end;
  p3:=y;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  yspan:=0.01;
  self.DoubleBuffered:=true;
  pb.ControlStyle:=pb.controlstyle +  [csOpaque];
//    sntp.Host:='n1.taur.dk';
  randomize;



end;

procedure TForm1.FormShow(Sender: TObject);
var i:integer;
begin
  if not showflag then begin
    memo1.lines.clear;
    showflag:=true;

    try
      http.Get('http://n1.taur.dk/nft/kill001.php');
      i:=1;
    except
      i:=0;
    end;

    if i=1 then begin
      application.messagebox(
      'This likely means that a bug was discoverd that causes'#10+
      'undesirably high load and traffic charges to the author''s'#10+
      'servers and internet connection. In that case see '#10#10+
      'http://n1.taur.dk/nft '#10#10+
      'for information. There might be a fixed version.'
      ,'The author kas kill-bitted this application',0);
      halt;

    end;


    if form2.showmodal<>mrok then close
    else begin
        if form2.Edit4.text<>'' then begin
          udp.Host:=form2.Edit4.text;
          udp.port:=123;
          udp.Active:=true;
        end;
        probeinterval:=round(strtofloat(form2.Edit5.text)*1000);
        timer1.Interval:=probeinterval;

        initialsample:=2;
        sampler:=Trxer.create(true);
        sampler.devicename:=form2.edit1.text;
        sampler.baudrate:=strtoint(form2.edit2.text);
        sampler.bytesize:=strtoint(form2.combobox2.text);
        sampler.expected:=strtofloat(form2.edit3.text);
        sampler.Resume;
        sleep(500);
        memo1.lines.add('start_sampler_thread(): '+sampler.status);
    end;
  end;

end;
{
  0 0           s
  1 1.5         d
  0 2.95        d
  1 4.43        d
  0 5.9         d
  1 7.38        d
  0 8.85
  1 10.325
  0 11.80
  1 13.27
  0 14.75
  1 16.22
  0 17.7
  1 19.2
  0 20.64


57600

0      0   start
0.74   1
1.47   0
2.21   1
2.95   0
3.68   1
4.42   0
5.16   1
5.89   0
6.63   1
7.34   0
8.11   1
8.85   0
9.58   1
10.32  0
 57600 7 bit

 }


{
------------------------

78125 bps /  115200

  0
  0.678
  1.34
  2.03
  2.71
  3.39
  4.07
  4.74
  5.42
  6.10
  6.78
  7.46
  8.13
  8.81
  9.50
  10.17




 }














//



function TForm1.getxtime: extended;
begin
  sampler.cs.Enter;
  result:=sampler.accumerror2;
  sampler.cs.Leave;
end;

procedure TForm1.pbPaint(Sender: TObject);
var c:Tcanvas;
    x0,t0,y0,ygain,x,y,maxy,miny:double;
    tmul:double;
    i:integer;
begin
//
  c:=pb.Canvas;
  c.brush.Color:=0;
  c.brush.Style:=bssolid;
  c.pen.color:=0;
  c.FillRect(rect(0,0,pb.width,pb.height));

  if dataix<2 then begin
    c.Font.size:=12;
    c.font.color:=$FFFFFF;
    c.brush.Style:=bsclear;
    if radiobutton1.Checked then
      c.TextOut(3,0,'not running')
    else
      c.TextOut(3,0,'waiting for data');
    exit;
  end;

  if checkbox1.Checked then begin
    yspan:=(data[dataix-1].time-data[0].time)*bestfit;

  end;


  t0:=data[0].time;
  tmul:=(pb.Width-10) /(data[dataix-1].time-t0);
  x0:=5;
  y0:=pb.Height/2;
  ygain:=pb.Height/2 /yspan;

  c.pen.Color:=$FF8080;
  c.MoveTo(round(x0),round(y0));
  c.LineTo(round(x0+(data[dataix-1].time-t0)*tmul),round(y0));

  maxy:=0;
  miny:=0;
  c.pen.Color:=$8080FF;
  for i:=0 to dataix-1 do begin
    y:=(data[i].tx+0.5*ntpgap);
    if i=0 then begin
      c.MoveTo(round(x0+(data[i].time-t0)*tmul),round(y0+ygain*y));
      //if y>maxy then maxy:=y;
      if y<miny then miny:=y;
    end else if data[i].rx-data[i].tx<suppresslimit then begin
      c.LineTo(round(x0+(data[i].time-t0)*tmul),round(y0+ygain*y));
      //if y>maxy then maxy:=y;
      if y<miny then miny:=y;
    end;
  end;

  c.pen.Color:=$80FF80;
  for i:=0 to dataix-1 do begin
    y:=(data[i].rx-0.5*ntpgap);
    if i=0 then begin
      c.MoveTo(round(x0+(data[i].time-t0)*tmul),round(y0+ygain*y));
      if y>maxy then maxy:=y;
      //if y<miny then miny:=y;
    end else if data[i].rx-data[i].tx<suppresslimit then begin
      c.LineTo(round(x0+(data[i].time-t0)*tmul),round(y0+ygain*y));
      if y>maxy then maxy:=y;
      //if y<miny then miny:=y;
    end;
  end;

  c.Font.size:=12;
  c.font.color:=$FFFFFF;
  c.brush.Style:=bsclear;
  x:=data[dataix-1].time-data[0].time;
  c.TextOut(3,0,'yspan '+floattostrf(yspan*2000,fffixed,20,1)+' ms (eq. +/-'+floattostrf(yspan/x*1E6,fffixed,20,1)+' ppm)');
  c.TextOut(3,c.TextHeight('Yg'),'runtime '+floattostrf(x,fffixed,20,0)+' s');

  if (maxy>yspan) or (miny<-yspan) then yspan:=yspan*2
  else
  if (maxy<0.47*yspan) and (miny>-0.47*yspan) then yspan:=yspan*0.5;
end;

procedure TForm1.radiochg(Sender: TObject);
begin
  pb.Invalidate;
end;

type Tntp	= packed record
    Head1: byte;
    Head2: shortint;
    Head3: shortint;
    Head4: shortint;
    RootDelay: longword;
    RootDispersion: longword;
    RefID: longword;
    Ref1: longword;
    Ref2: longword;
    Org1: longword;
    Org2: longword;
    Rcv1: longword;
    Rcv2: longword;
    Xmit1: longword;
    Xmit2: longword;
  end;


function swp(x:longword):longword;
asm bswap eax; end;

procedure TForm1.Timer1Timer(Sender: TObject);
var f,sx,sy,sxx,sxy,x,y:double;
    txtimey,rxtimey,perfrq:int64;
    txtime,rxtime,err:double;
    i,sp:integer;
    nt:Tntp;
    bf:Tbytes;
begin
  if sampler=nil then exit;

  if not radiobutton1.checked then begin

    with nt do begin
      Head1:=$23;
      Head2:=0;
      Head3:=0;
      Head4:=0;
      RootDelay:=0;
      RootDispersion:=0;
      RefID:=0;
      Ref1:=0;
      Ref2:=0;
      Org1:=0;
      Org2:=0;
      Rcv1:=0;
      Rcv2:=0;
      Xmit1:=0;
      Xmit2:=0;
    end;

    setlength(bf,sizeof(nt));
    move(nt,bf[0],sizeof(nt));

    if udp.Active then begin
      queryperformancefrequency(perfrq);
      err:=getxtime;
      queryperformancecounter(txtimey);
      udp.SendBuffer(bf);
      i:=udp.ReceiveBuffer(bf,500);
      queryperformancecounter(rxtimey);

      if i<>sizeof(nt) then exit; //bad sample
      move(bf[0],nt,sizeof(nt));

      if nt.Head2=0 then begin
        application.MessageBox('KoD packet received from the NTP server','Go Away received from server,0');
        radiobutton1.Checked:=true;
      end;
      x:=swp(nt.xmit1);
      x:=x+swp(nt.xmit2)*232.830643654e-12;
      y:=swp(nt.rcv1);
      y:=y+swp(nt.rcv2)*232.830643654e-12;
    end else begin
      queryperformancefrequency(perfrq);
      err:=getxtime;
      queryperformancecounter(txtimey);
      rxtimey:=txtimey;
      x:=txtimey;
      x:=x/perfrq;
      y:=x;
    end;


    txtime:=(txtimey/perfrq)+err;
    rxtime:=(rxtimey/perfrq)+err;
    //f:=f*86400.0;
    //ref and rcv are set by the server.


    f:=x-y; //server processing delay

    x:=x-f; //tweak server tx time and our receive time
    rxtime:=rxtime-f;
    //now it looks like the server was instantaneous

    f:=(x+y)/2; //this is really a dummy once the timing has been tweaked.

    if initialsample>0 then begin
      initialref:=(txtime+rxtime)/2{ rxtime};
      initialntp:=f;
      ntpgap:=rxtime-txtime;
      dec(initialsample);
      dataix:=0;
      sum_roundtrip:=0;
    end;
    txtime:=txtime-initialref;
    rxtime:=rxtime-initialref;
    f:=f-initialntp;

    sum_roundtrip :=sum_roundtrip+(rxtime-txtime);

    if rxtime-txtime<ntpgap then ntpgap:=rxtime-txtime;

    label4.Caption:='acquired ntp='+floattostrf(f,fffixed,20,4)+' tx='+floattostrf(txtime,fffixed,20,4)+' rx='+floattostrf(rxtime,fffixed,20,3)+' mingap='+floattostrf(ntpgap,fffixed,20,4);

    if length(data)>=dataix then setlength(data,dataix+86400);
    with data[dataix] do begin
      time:=f;
      tx:=txtime-f;
      rx:=rxtime-f;
    end;
    inc(dataix);


    if dataix>1 then begin
      label5.Caption:=floattostrf(
       (data[0].rx-data[dataix-1].rx)/(data[0].time-data[dataix-1].time)*1E6,fffixed,20,2)+' ppm';

    end;
//    cantilever_track;


    sx:=0; sy:=0; sxx:=0; sxy:=0;
    sp:=0;
    f:=1.3*(sum_roundtrip / dataix)+0.003;
    suppresslimit:=f;
    for i:=0 to dataix-1 do begin
      if (data[i].rx-data[i].tx)<f then begin
        x:=data[i].time;
        y:=data[i].tx+data[i].rx;

        sx:=sx+x;
        sy:=sy+y;
        sxx:=sxx+x*x;
        sxy:=sxy+x*y;
        inc(sp);
      end;
    end;
    if sp>2 then begin
      f := (sp*sxy-sx*sy)/(sp*sxx-sx*sx);
      f:=f/2.0*1E6;
      label7.Caption:=floattostrf(f,fffixed,20,2)+' ppm';
    end;

    bestfit:=f*1.0E-6;

    pb.Invalidate;
    timer1.Interval:=probeinterval+random(100);

    x:=data[dataix-1].time-data[0].time;

    if (radiobutton3.Checked and (x>100)) or
       (radiobutton4.Checked and (x>300)) or
       (radiobutton5.Checked and (x>1000)) or
       (radiobutton6.Checked and (x>3600)) then begin
      memo1.lines.add('result: '+label7.caption);
      initialsample:=2;
    end;
  end;


end;

procedure TForm1.Timer2Timer(Sender: TObject);
var f:double;
begin
  if sampler=nil then exit;
  lmeasevent.caption:=inttostr(sampler.pipct);
  f:=sampler.accumerror2;
  lpcrelative.caption:=floattostrf(f,fffixed,20,6);
  label3.caption:=floattostrf((f-deltalasttik)*1E6,fffixed,20,0)+' ppm';
  deltalasttik:=f;
end;

end.


-0,3 ppm
0,1 ppm
-0,5 ppm
0,0 ppm
-0,4 ppm
-0,2 ppm
0,5 ppm
0,6 ppm
-0,1 ppm
0,4 ppm
-0,3 ppm
-0,6 ppm
0,3 ppm
0,0 ppm
-0,4 ppm
0,2 ppm
-0,9 ppm
-0,4 ppm
0,0 ppm
-0,3 ppm
-0,4 ppm
-0,1 ppm
0,2 ppm
-0,3 ppm
-0,5 ppm
0,2 ppm
-0,1 ppm
0,3 ppm
0,2 ppm
-0,2 ppm
0,0 ppm
-0,9 ppm
-0,2 ppm
-0,2 ppm
-0,2 ppm
0,0 ppm
-0,3 ppm
-0,9 ppm
0,0 ppm
0,5 ppm
-0,1 ppm
-0,2 ppm
-0,5 ppm
-0,2 ppm
-0,6 ppm
0,4 ppm
-0,3 ppm
0,6 ppm
0,2 ppm
0,0 ppm
0,0 ppm
-0,1 ppm
0,2 ppm
-0,2 ppm
0,3 ppm
0,5 ppm
0,1 ppm
-0,3 ppm
-0,7 ppm
-0,3 ppm
-0,1 ppm
0,1 ppm
-0,1 ppm
0,0 ppm
0,9 ppm
0,2 ppm
-0,2 ppm
0,7 ppm
-0,3 ppm
0,3 ppm
-0,3 ppm
-0,2 ppm
0,5 ppm
0,3 ppm
0,2 ppm
0,0 ppm
-0,3 ppm
-0,7 ppm
0,1 ppm
0,4 ppm
0,5 ppm
-1,0 ppm
0,0 ppm
0,1 ppm
-0,1 ppm
-0,3 ppm
-0,4 ppm
-0,1 ppm
0,0 ppm
0,2 ppm
0,0 ppm
-0,3 ppm
-0,1 ppm
0,7 ppm
0,4 ppm
-0,3 ppm
0,4 ppm
0,5 ppm
-0,2 ppm
-0,3 ppm
0,5 ppm
0,2 ppm
0,4 ppm
-0,6 ppm
0,0 ppm
-0,3 ppm
-0,5 ppm
0,1 ppm
0,0 ppm
0,0 ppm
0,5 ppm
0,3 ppm
-0,3 ppm
-0,2 ppm
0,3 ppm
-0,2 ppm
-0,6 ppm
0,7 ppm
-0,2 ppm
0,5 ppm
0,2 ppm
-0,9 ppm
-0,4 ppm
0,1 ppm
-1,1 ppm
0,5 ppm
-0,1 ppm
0,0 ppm
-0,3 ppm
0,2 ppm
-0,2 ppm
0,4 ppm
-0,8 ppm
0,3 ppm
0,4 ppm
-0,4 ppm
0,2 ppm
-0,8 ppm
-0,3 ppm
0,5 ppm
0,1 ppm
0,2 ppm
-0,2 ppm
1,0 ppm
-0,4 ppm
0,1 ppm
-0,2 ppm
-0,3 ppm
-0,5 ppm
-1,0 ppm
0,5 ppm
-0,2 ppm
-0,6 ppm
-0,2 ppm
0,6 ppm
-0,6 ppm
0,0 ppm
-0,3 ppm
-1,1 ppm
-0,3 ppm
-0,3 ppm

